// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

/* TODO

Diariamente:
  cada 1,2,3.... dias
  Ejemplo: cada 4 dias
	RRULE:FREQ=DAILY;INTERVAL=4
	
Semanalmente:
	cada 1,2,3.... semanas los dias lunes, martes y viernes....
	Ejemplo: cada 2 semanas el lunes y viernes
	RRULE:FREQ=WEEKLY;INTERVAL=2;BYDAY=MO,FR;WKST=MO
	
Mensualmente:
  cada 1,2,3.... meses los dias {
						1, 4, 6 y 10....
						el primer martes (de cada mes)
					}
	Ejemplo: cada 3 meses cada 10, 18 y 30
	RRULE:FREQ=MONTHLY;INTERVAL=3;BYMONTHDAY=10,18,30
					
Anualmente:
	cada 1,2,3... aos los meses enero, febrero, marzo.....



FROM RFC2445

   Example: All examples assume the Eastern United States time zone.

   Daily for 10 occurrences:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=DAILY;COUNT=10

     ==> (1997 9:00 AM EDT)September 2-11

   Daily until December 24, 1997:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=DAILY;UNTIL=19971224T000000Z

     ==> (1997 9:00 AM EDT)September 2-30;October 1-25
         (1997 9:00 AM EST)October 26-31;November 1-30;December 1-23

   Every other day - forever:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=DAILY;INTERVAL=2
     ==> (1997 9:00 AM EDT)September2,4,6,8...24,26,28,30;
          October 2,4,6...20,22,24
         (1997 9:00 AM EST)October 26,28,30;November 1,3,5,7...25,27,29;
          Dec 1,3,...

   Every 10 days, 5 occurrences:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=DAILY;INTERVAL=10;COUNT=5

     ==> (1997 9:00 AM EDT)September 2,12,22;October 2,12

   Everyday in January, for 3 years:

     DTSTART;TZID=US-Eastern:19980101T090000
     RRULE:FREQ=YEARLY;UNTIL=20000131T090000Z;
      BYMONTH=1;BYDAY=SU,MO,TU,WE,TH,FR,SA
     or
     RRULE:FREQ=DAILY;UNTIL=20000131T090000Z;BYMONTH=1

     ==> (1998 9:00 AM EDT)January 1-31
         (1999 9:00 AM EDT)January 1-31
         (2000 9:00 AM EDT)January 1-31

   Weekly for 10 occurrences

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=WEEKLY;COUNT=10

     ==> (1997 9:00 AM EDT)September 2,9,16,23,30;October 7,14,21
         (1997 9:00 AM EST)October 28;November 4

   Weekly until December 24, 1997

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=WEEKLY;UNTIL=19971224T000000Z

     ==> (1997 9:00 AM EDT)September 2,9,16,23,30;October 7,14,21
         (1997 9:00 AM EST)October 28;November 4,11,18,25;
                           December 2,9,16,23
   Every other week - forever:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=WEEKLY;INTERVAL=2;WKST=SU

     ==> (1997 9:00 AM EDT)September 2,16,30;October 14
         (1997 9:00 AM EST)October 28;November 11,25;December 9,23
         (1998 9:00 AM EST)January 6,20;February
     ...

   Weekly on Tuesday and Thursday for 5 weeks:

    DTSTART;TZID=US-Eastern:19970902T090000
    RRULE:FREQ=WEEKLY;UNTIL=19971007T000000Z;WKST=SU;BYDAY=TU,TH
    or
    RRULE:FREQ=WEEKLY;COUNT=10;WKST=SU;BYDAY=TU,TH

    ==> (1997 9:00 AM EDT)September 2,4,9,11,16,18,23,25,30;October 2

   Every other week on Monday, Wednesday and Friday until December 24,
   1997, but starting on Tuesday, September 2, 1997:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=WEEKLY;INTERVAL=2;UNTIL=19971224T000000Z;WKST=SU;
      BYDAY=MO,WE,FR
     ==> (1997 9:00 AM EDT)September 2,3,5,15,17,19,29;October
     1,3,13,15,17
         (1997 9:00 AM EST)October 27,29,31;November 10,12,14,24,26,28;
                           December 8,10,12,22

   Every other week on Tuesday and Thursday, for 8 occurrences:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=WEEKLY;INTERVAL=2;COUNT=8;WKST=SU;BYDAY=TU,TH

     ==> (1997 9:00 AM EDT)September 2,4,16,18,30;October 2,14,16

   Monthly on the 1st Friday for ten occurrences:

     DTSTART;TZID=US-Eastern:19970905T090000
     RRULE:FREQ=MONTHLY;COUNT=10;BYDAY=1FR

     ==> (1997 9:00 AM EDT)September 5;October 3
         (1997 9:00 AM EST)November 7;Dec 5
         (1998 9:00 AM EST)January 2;February 6;March 6;April 3
         (1998 9:00 AM EDT)May 1;June 5

   Monthly on the 1st Friday until December 24, 1997:

     DTSTART;TZID=US-Eastern:19970905T090000
     RRULE:FREQ=MONTHLY;UNTIL=19971224T000000Z;BYDAY=1FR

     ==> (1997 9:00 AM EDT)September 5;October 3
         (1997 9:00 AM EST)November 7;December 5

   Every other month on the 1st and last Sunday of the month for 10
   occurrences:

     DTSTART;TZID=US-Eastern:19970907T090000
     RRULE:FREQ=MONTHLY;INTERVAL=2;COUNT=10;BYDAY=1SU,-1SU

     ==> (1997 9:00 AM EDT)September 7,28
         (1997 9:00 AM EST)November 2,30
         (1998 9:00 AM EST)January 4,25;March 1,29
         (1998 9:00 AM EDT)May 3,31

   Monthly on the second to last Monday of the month for 6 months:

     DTSTART;TZID=US-Eastern:19970922T090000
     RRULE:FREQ=MONTHLY;COUNT=6;BYDAY=-2MO

     ==> (1997 9:00 AM EDT)September 22;October 20
         (1997 9:00 AM EST)November 17;December 22
         (1998 9:00 AM EST)January 19;February 16

   Monthly on the third to the last day of the month, forever:

     DTSTART;TZID=US-Eastern:19970928T090000
     RRULE:FREQ=MONTHLY;BYMONTHDAY=-3

     ==> (1997 9:00 AM EDT)September 28
         (1997 9:00 AM EST)October 29;November 28;December 29
         (1998 9:00 AM EST)January 29;February 26
     ...

   Monthly on the 2nd and 15th of the month for 10 occurrences:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=MONTHLY;COUNT=10;BYMONTHDAY=2,15

     ==> (1997 9:00 AM EDT)September 2,15;October 2,15
         (1997 9:00 AM EST)November 2,15;December 2,15
         (1998 9:00 AM EST)January 2,15

   Monthly on the first and last day of the month for 10 occurrences:

     DTSTART;TZID=US-Eastern:19970930T090000
     RRULE:FREQ=MONTHLY;COUNT=10;BYMONTHDAY=1,-1

     ==> (1997 9:00 AM EDT)September 30;October 1
         (1997 9:00 AM EST)October 31;November 1,30;December 1,31
         (1998 9:00 AM EST)January 1,31;February 1

   Every 18 months on the 10th thru 15th of the month for 10
   occurrences:

     DTSTART;TZID=US-Eastern:19970910T090000
     RRULE:FREQ=MONTHLY;INTERVAL=18;COUNT=10;BYMONTHDAY=10,11,12,13,14,
      15

     ==> (1997 9:00 AM EDT)September 10,11,12,13,14,15
         (1999 9:00 AM EST)March 10,11,12,13

   Every Tuesday, every other month:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=MONTHLY;INTERVAL=2;BYDAY=TU

     ==> (1997 9:00 AM EDT)September 2,9,16,23,30
         (1997 9:00 AM EST)November 4,11,18,25
         (1998 9:00 AM EST)January 6,13,20,27;March 3,10,17,24,31
     ...

   Yearly in June and July for 10 occurrences:

     DTSTART;TZID=US-Eastern:19970610T090000
     RRULE:FREQ=YEARLY;COUNT=10;BYMONTH=6,7
     ==> (1997 9:00 AM EDT)June 10;July 10
         (1998 9:00 AM EDT)June 10;July 10
         (1999 9:00 AM EDT)June 10;July 10
         (2000 9:00 AM EDT)June 10;July 10
         (2001 9:00 AM EDT)June 10;July 10
     Note: Since none of the BYDAY, BYMONTHDAY or BYYEARDAY components
     are specified, the day is gotten from DTSTART

   Every other year on January, February, and March for 10 occurrences:

     DTSTART;TZID=US-Eastern:19970310T090000
     RRULE:FREQ=YEARLY;INTERVAL=2;COUNT=10;BYMONTH=1,2,3

     ==> (1997 9:00 AM EST)March 10
         (1999 9:00 AM EST)January 10;February 10;March 10
         (2001 9:00 AM EST)January 10;February 10;March 10
         (2003 9:00 AM EST)January 10;February 10;March 10

   Every 3rd year on the 1st, 100th and 200th day for 10 occurrences:

     DTSTART;TZID=US-Eastern:19970101T090000
     RRULE:FREQ=YEARLY;INTERVAL=3;COUNT=10;BYYEARDAY=1,100,200

     ==> (1997 9:00 AM EST)January 1
         (1997 9:00 AM EDT)April 10;July 19
         (2000 9:00 AM EST)January 1
         (2000 9:00 AM EDT)April 9;July 18
         (2003 9:00 AM EST)January 1
         (2003 9:00 AM EDT)April 10;July 19
         (2006 9:00 AM EST)January 1

   Every 20th Monday of the year, forever:

     DTSTART;TZID=US-Eastern:19970519T090000
     RRULE:FREQ=YEARLY;BYDAY=20MO

     ==> (1997 9:00 AM EDT)May 19
         (1998 9:00 AM EDT)May 18
         (1999 9:00 AM EDT)May 17
     ...

   Monday of week number 20 (where the default start of the week is
   Monday), forever:

     DTSTART;TZID=US-Eastern:19970512T090000
     RRULE:FREQ=YEARLY;BYWEEKNO=20;BYDAY=MO

     ==> (1997 9:00 AM EDT)May 12
         (1998 9:00 AM EDT)May 11
         (1999 9:00 AM EDT)May 17
     ...

   Every Thursday in March, forever:

     DTSTART;TZID=US-Eastern:19970313T090000
     RRULE:FREQ=YEARLY;BYMONTH=3;BYDAY=TH

     ==> (1997 9:00 AM EST)March 13,20,27
         (1998 9:00 AM EST)March 5,12,19,26
         (1999 9:00 AM EST)March 4,11,18,25
     ...

   Every Thursday, but only during June, July, and August, forever:

     DTSTART;TZID=US-Eastern:19970605T090000
     RRULE:FREQ=YEARLY;BYDAY=TH;BYMONTH=6,7,8

     ==> (1997 9:00 AM EDT)June 5,12,19,26;July 3,10,17,24,31;
                       August 7,14,21,28
         (1998 9:00 AM EDT)June 4,11,18,25;July 2,9,16,23,30;
                       August 6,13,20,27
         (1999 9:00 AM EDT)June 3,10,17,24;July 1,8,15,22,29;
                       August 5,12,19,26
     ...

   Every Friday the 13th, forever:

     DTSTART;TZID=US-Eastern:19970902T090000
     EXDATE;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=MONTHLY;BYDAY=FR;BYMONTHDAY=13

     ==> (1998 9:00 AM EST)February 13;March 13;November 13
         (1999 9:00 AM EDT)August 13
         (2000 9:00 AM EDT)October 13
     ...

   The first Saturday that follows the first Sunday of the month,
    forever:

     DTSTART;TZID=US-Eastern:19970913T090000
     RRULE:FREQ=MONTHLY;BYDAY=SA;BYMONTHDAY=7,8,9,10,11,12,13

     ==> (1997 9:00 AM EDT)September 13;October 11
         (1997 9:00 AM EST)November 8;December 13
         (1998 9:00 AM EST)January 10;February 7;March 7
         (1998 9:00 AM EDT)April 11;May 9;June 13...
     ...

   Every four years, the first Tuesday after a Monday in November,
   forever (U.S. Presidential Election day):

     DTSTART;TZID=US-Eastern:19961105T090000
     RRULE:FREQ=YEARLY;INTERVAL=4;BYMONTH=11;BYDAY=TU;BYMONTHDAY=2,3,4,
      5,6,7,8

     ==> (1996 9:00 AM EST)November 5
         (2000 9:00 AM EST)November 7
         (2004 9:00 AM EST)November 2
     ...

   The 3rd instance into the month of one of Tuesday, Wednesday or
   Thursday, for the next 3 months:

     DTSTART;TZID=US-Eastern:19970904T090000
     RRULE:FREQ=MONTHLY;COUNT=3;BYDAY=TU,WE,TH;BYSETPOS=3

     ==> (1997 9:00 AM EDT)September 4;October 7
         (1997 9:00 AM EST)November 6

   The 2nd to last weekday of the month:

     DTSTART;TZID=US-Eastern:19970929T090000
     RRULE:FREQ=MONTHLY;BYDAY=MO,TU,WE,TH,FR;BYSETPOS=-2

     ==> (1997 9:00 AM EDT)September 29
         (1997 9:00 AM EST)October 30;November 27;December 30
         (1998 9:00 AM EST)January 29;February 26;March 30
     ...

   Every 3 hours from 9:00 AM to 5:00 PM on a specific day:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=HOURLY;INTERVAL=3;UNTIL=19970902T170000Z

     ==> (September 2, 1997 EDT)09:00,12:00,15:00

   Every 15 minutes for 6 occurrences:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=MINUTELY;INTERVAL=15;COUNT=6

     ==> (September 2, 1997 EDT)09:00,09:15,09:30,09:45,10:00,10:15

   Every hour and a half for 4 occurrences:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=MINUTELY;INTERVAL=90;COUNT=4

     ==> (September 2, 1997 EDT)09:00,10:30;12:00;13:30

   Every 20 minutes from 9:00 AM to 4:40 PM every day:

     DTSTART;TZID=US-Eastern:19970902T090000
     RRULE:FREQ=DAILY;BYHOUR=9,10,11,12,13,14,15,16;BYMINUTE=0,20,40
     or
     RRULE:FREQ=MINUTELY;INTERVAL=20;BYHOUR=9,10,11,12,13,14,15,16

     ==> (September 2, 1997 EDT)9:00,9:20,9:40,10:00,10:20,
                                ... 16:00,16:20,16:40
         (September 3, 1997 EDT)9:00,9:20,9:40,10:00,10:20,
                               ...16:00,16:20,16:40
     ...

   An example where the days generated makes a difference because of
   WKST:

     DTSTART;TZID=US-Eastern:19970805T090000
     RRULE:FREQ=WEEKLY;INTERVAL=2;COUNT=4;BYDAY=TU,SU;WKST=MO

     ==> (1997 EDT)Aug 5,10,19,24

     changing only WKST from MO to SU, yields different results...

     DTSTART;TZID=US-Eastern:19970805T090000
     RRULE:FREQ=WEEKLY;INTERVAL=2;COUNT=4;BYDAY=TU,SU;WKST=SU
     ==> (1997 EDT)August 5,17,19,31


*/

namespace CalWidget {
	using System;
	using System.IO;
	using System.Collections;
	using System.Reflection;

  public enum FrequenceOfTask { Daily, Weekly, Monthly, Yearly }

	class DateTimeMC {
		public static System.DateTime Parse(string dateParam) {
			System.DateTime aux;
			string date = dateParam.Remove(8,1);

			if (date.EndsWith("Z")) {
				aux = System.DateTime.ParseExact(date.Remove(date.Length-1,1), "yyyyMMddHHmmss", null);
				aux = aux + (System.DateTime.Now - System.DateTime.UtcNow);
			} else {
				aux = System.DateTime.ParseExact(date, "yyyyMMddHHmmss", null);
			}

			return aux;
		}
	}
  
	public class Rule {
		public FrequenceOfTask Type;
		public int Interval;
		public System.DateTime Until;

		public override string ToString() {
			return String.Format ("Type: {0} Interval: {1} Until: {2}", Type, Interval, Until);
		}

		public void Parse(string value)
		{
			foreach (string aux in value.Split(';')) {
				switch (aux.Substring(0, aux.IndexOf('=')).ToLower()) {
					case "freq":
						switch (aux.Substring(aux.IndexOf('=')+1).ToLower()) {
							case "daily":
								Type = FrequenceOfTask.Daily;
								break;
							case "weekly":
								Type = FrequenceOfTask.Weekly;
								break;
							case "monthly":
								Type = FrequenceOfTask.Monthly;
								break;
							case "yearly":
								Type = FrequenceOfTask.Yearly;
								break;
							default:
								Console.WriteLine("Not implemented in Rule.Parse: {0}", aux);
								break;
						}
						break;
					case "interval":
						Interval = int.Parse(aux.Substring(aux.IndexOf('=')+1).ToLower());
						break;
					case "until":
						Until = CalWidget.DateTimeMC.Parse(aux.Substring(aux.IndexOf('=')+1));
						break;
					default:
						Console.WriteLine("Not implemented in Rule.Parse: {0}", aux);
						break;
				}
			}
		}
	}

	public class CalTask {
		public System.DateTime start;
		public System.DateTime end;
		string duration;
		string summary;
		string uid;
		Rule rrule = null;

		public override string ToString() {
			return String.Format ("Summary: {0}\nStart: {1}\nEnd: {2}\nDuration: {3}\nUid: {4}\nRRule: {5}", summary, start, end, duration, uid, rrule);
		}

		public bool IsInDate(System.DateTime date)
		{
			if (start.ToString("yyyyMMdd") == date.ToString("yyyyMMdd"))
				return true;
			if (rrule == null) return false;
			if ((start < date) && (date < rrule.Until)) {
				switch (rrule.Type) {
					case FrequenceOfTask.Daily:
						return true;
					case FrequenceOfTask.Weekly:
						if (start.DayOfWeek == date.DayOfWeek)
							return true;
						break;
					case FrequenceOfTask.Monthly:
						if (start.Day == date.Day)
							return true;
						break;
					case FrequenceOfTask.Yearly:
						if ((start.Month == date.Month) && (start.Day == date.Day))
							return true;
						break;
				}
			}
			return false;
		}

		public string Start {
			get {
				return start.ToString();
			}
			set {
				//start = System.DateTime.ParseExact(value.Remove(8,1), "yyyyMMddHHmmss", null);
				start = CalWidget.DateTimeMC.Parse(value);
			}
		}

		public String Summary {
			get {
				return summary;
			}
			set {
				summary = value;
			}
		}

		public String End {
			get {
				if (end.Year == 1) return "";
				return end.ToString();
			}
			set {
//				end = System.DateTime.ParseExact(value.Remove(8,1), "yyyyMMddHHmmss", null);
				end = CalWidget.DateTimeMC.Parse(value);
			}
		}

		public String Duration {
			get {
				return duration;
			}
			set {
				if (value.StartsWith("PT")) {
					if (value.EndsWith("H")) {
						string hours = value.Remove(0,2);
						hours = hours.Remove(hours.Length-1, 1);
						end = start.AddHours(int.Parse(hours));
					}
					if (value.EndsWith("S")) {
						string seg = value.Remove(0,2);
						seg = seg.Remove(seg.Length-1, 1);
						end = start.AddSeconds(int.Parse(seg));
					}
				}
				duration = value;
			}
		}

		public Rule RRule {
			get {
				return rrule;
			}
			set {
				rrule = value;
			}
		}

		public String UID {
			get {
				return uid;
			}
			set {
				uid = value;
			}
		}
	}

	public class CalData {
		string calendarName;
		public ArrayList DataList;
		bool visible = true;
		bool selected = false;
		static int i = 0;
		System.Drawing.Color colorBorder, colorText, colorBgUnselected, colorBgSelectedLeft, colorBgSelectedRight;

		public CalData()
		{
			DataList = new ArrayList();

			switch (i) {
				case 0: // Azul
					colorBorder = System.Drawing.Color.FromArgb(255, 0, 81, 212);
					colorText = System.Drawing.Color.FromArgb(255, 255, 255, 255);
					colorBgUnselected = System.Drawing.Color.FromArgb(200, 141, 181, 242);
					colorBgSelectedLeft = System.Drawing.Color.FromArgb(255, 28, 104, 224);
					colorBgSelectedRight = System.Drawing.Color.FromArgb(255, 90, 149, 245);
					break;
				case 1: // Naranja
					colorBorder = System.Drawing.Color.FromArgb(255, 245, 118, 0);
					colorText = System.Drawing.Color.FromArgb(255, 255, 255, 255);
					colorBgUnselected = System.Drawing.Color.FromArgb(200, 245, 211, 180);
					colorBgSelectedLeft = System.Drawing.Color.FromArgb(255, 247, 129, 17);
					colorBgSelectedRight = System.Drawing.Color.FromArgb(255, 255, 164, 79);
					break;
				case 2: // Rosa
					colorBorder = System.Drawing.Color.FromArgb(255, 176, 39, 174);
					colorText = System.Drawing.Color.FromArgb(255, 255, 255, 255);
					colorBgUnselected = System.Drawing.Color.FromArgb(200, 232, 171, 232);
					colorBgSelectedLeft = System.Drawing.Color.FromArgb(255, 186, 67, 184);
					colorBgSelectedRight = System.Drawing.Color.FromArgb(255, 196, 90, 196);
					break;
				case 3: // Rojo
					colorBorder = System.Drawing.Color.FromArgb(255, 230, 23, 23);
					colorText = System.Drawing.Color.FromArgb(255, 255, 255, 255);
					colorBgUnselected = System.Drawing.Color.FromArgb(200, 251, 171, 171);
					colorBgSelectedLeft = System.Drawing.Color.FromArgb(255, 244, 44, 44);
					colorBgSelectedRight = System.Drawing.Color.FromArgb(255, 250, 97, 97);
					break;
				case 5: // Violeta
					colorBorder = System.Drawing.Color.FromArgb(255, 73, 43, 161);
					colorText = System.Drawing.Color.FromArgb(255, 255, 255, 255);
					colorBgUnselected = System.Drawing.Color.FromArgb(200, 195, 183, 233);
					colorBgSelectedLeft = System.Drawing.Color.FromArgb(255, 92, 64, 176);
					colorBgSelectedRight = System.Drawing.Color.FromArgb(255, 171, 149, 237);
					break;
				case 4: // Verde
				default:
					colorBorder = System.Drawing.Color.FromArgb(255, 44, 161, 11);
					colorText = System.Drawing.Color.FromArgb(255, 255, 255, 255);
					colorBgUnselected = System.Drawing.Color.FromArgb(200, 158, 241, 136);
					colorBgSelectedLeft = System.Drawing.Color.FromArgb(255, 68, 173, 38);
					colorBgSelectedRight = System.Drawing.Color.FromArgb(255, 113, 194, 91);
					break;
			}

			i = ((i + 1)%6);
		}


  		public System.Drawing.Color ColorBorder {
			get {
				return colorBorder;
			}
		}

		public System.Drawing.Color ColorText {
			get {
				return colorText;
			}
		}

		public System.Drawing.Color ColorBgUnselected {
			get {
				return colorBgUnselected;
			}
		}

		public System.Drawing.Color ColorBgSelectedLeft {
			get {
				return colorBgSelectedLeft;
			}
		}

		public System.Drawing.Color ColorBgSelectedRight {
			get {
				return colorBgSelectedRight;
			}
		}

		public bool Visible {
			get {
				return visible;
			}
			set {
				visible = value;
			}
		}

		public bool Selected {
			get {
				return selected;
			}
			set {
				selected = value;
			}
		}

		public void SaveICS(string file)
		{
			using(TextWriter streamWriter = new StreamWriter(file))
			{
				streamWriter.WriteLine("BEGIN:VCALENDAR");
				streamWriter.WriteLine("VERSION:2.0");
				streamWriter.WriteLine("X-WR-CALNAME:{0}", calendarName);
				Version v = Assembly.GetEntryAssembly().GetName().Version;
				streamWriter.WriteLine("PRODID:-//BorSanZa//MonoCalendar {0}.{1}.{2}//ES", v.Major, v.Minor, v.Build);
/*
 			Console.WriteLine("X-WR-RELCALID:AB4841F6-87AD-11D9-83B2-001124308426");
			Console.WriteLine("X-WR-TIMEZONE:Europe/Madrid");
			Console.WriteLine("CALSCALE:GREGORIAN");
			Console.WriteLine("METHOD:PUBLISH");
			Console.WriteLine("BEGIN:VTIMEZONE");
			Console.WriteLine("TZID:Europe/Madrid");
			Console.WriteLine("LAST-MODIFIED:20050226T041955Z");
			Console.WriteLine("BEGIN:STANDARD");
			Console.WriteLine("DTSTART:20041031T010000");
			Console.WriteLine("TZOFFSETTO:+0100");
			Console.WriteLine("TZOFFSETFROM:+0000");
			Console.WriteLine("TZNAME:CET");
			Console.WriteLine("END:STANDARD");
			Console.WriteLine("BEGIN:DAYLIGHT");
			Console.WriteLine("DTSTART:20050327T030000");
			Console.WriteLine("TZOFFSETTO:+0200");
			Console.WriteLine("TZOFFSETFROM:+0100");
			Console.WriteLine("TZNAME:CEST");
			Console.WriteLine("END:DAYLIGHT");
			Console.WriteLine("END:VTIMEZONE");
*/

				string freq = "WEEKLY";
				foreach (CalTask ct in DataList) {
					streamWriter.WriteLine("BEGIN:VEVENT"); // Hecho
					streamWriter.WriteLine(String.Format("DTSTART;TZID=Europe/Madrid:{0}T{1}", ct.start.ToString("yyyyMMdd"), ct.start.ToString("HHmmss"))); // Hecho
					streamWriter.WriteLine(String.Format("DTEND;TZID=Europe/Madrid:{0}T{1}", ct.end.ToString("yyyyMMdd"), ct.end.ToString("HHmmss"))); // Hecho
					streamWriter.WriteLine(String.Format("SUMMARY:{0}", ct.Summary)); // Hecho
					streamWriter.WriteLine(String.Format("UID:{0}", ct.UID)); // Hecho
//				streamWriter.WriteLine("SEQUENCE:5");
//				streamWriter.WriteLine("DTSTAMP:20050226T041903Z");
					if (ct.RRule != null) {
						switch (ct.RRule.Type) {
							case FrequenceOfTask.Daily:
								freq = "DAILY";
								break;
							case FrequenceOfTask.Weekly:
								freq = "WEEKLY";
								break;
							case FrequenceOfTask.Monthly:
								freq = "MONTHLY";
								break;
							case FrequenceOfTask.Yearly:
								freq = "YEARLY";
								break;
						}
						streamWriter.WriteLine(String.Format("RRULE:FREQ={0};INTERVAL=1;UNTIL={1}T{2}Z", freq, ct.RRule.Until.ToUniversalTime().ToString("yyyyMMdd"), ct.RRule.Until.ToUniversalTime().ToString("HHmmss")));
					}
					streamWriter.WriteLine("END:VEVENT"); // Hecho
				}
				streamWriter.WriteLine("END:VCALENDAR");
			}
		}

		public void LoadICS(string file)
		{
			StreamReader sr = new StreamReader(file);
			string curLine;
			char character;
			CalTask ct = new CalTask();
			bool dentro = false;
			System.IO.FileInfo a = new System.IO.FileInfo(file);
			calendarName = a.Name;
			
			while (true) {
				curLine = sr.ReadLine();
				if (curLine == null) break;
				character =  ':';
				if (curLine.IndexOf(';') > 0) {
					if (curLine.IndexOf(':') > curLine.IndexOf(';')) character = ';';
				}
				if (curLine.IndexOf(character)<=0) continue;

				switch (curLine.Substring(0, curLine.IndexOf(character)).ToLower()) {
					case "x-wr-calname":
						calendarName = curLine.Substring(curLine.IndexOf(':') + 1);
						break;
					case "begin":
						if (curLine.Substring(curLine.IndexOf(':') + 1).ToLower() ==	"vevent") {
							ct = new CalTask();
							dentro = true;
						}
						break;
					case "dtstart":
						ct.Start = curLine.Substring(curLine.IndexOf(':') + 1);
						break;
					case "dtend":
						ct.End = curLine.Substring(curLine.IndexOf(':') + 1);
						break;
					case "summary":
						ct.Summary = curLine.Substring(curLine.IndexOf(':') + 1);
						break;
					case "rrule":
						ct.RRule = new Rule();
						ct.RRule.Parse( curLine.Substring(curLine.IndexOf(':') + 1));
						break;
					case "duration":
						ct.Duration = curLine.Substring(curLine.IndexOf(':') + 1);
						break;
					case "end":
						if (dentro) {
							DataList.Add(ct);
							ct = new CalTask();
						}
						break;
					case "uid":
						ct.UID = curLine.Substring(curLine.IndexOf(':') + 1);
						break;
					case "sequence":
					case "dtstamp":
						break;
					default:
						if (dentro)
							Console.WriteLine("Desconocido en ICS: {0}",curLine);
						break;
				}
			}
			sr.Close();
		}

		public string CalendarName {
			get {
				return calendarName;
			}
			set {
				calendarName = value;
			}
		}
	}
}
