// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

/*
namespace BorSanZaNET {
	using System;

	class MiniGConfEditor {

  		Gtk.Window MainWindow;
		Gtk.TreeView tree_values;
		Gtk.Notebook notebook1;
		Gtk.Label labelType;
		Gtk.ToggleButton togglebutton1;
		Gtk.Entry entry1;
		Gtk.SpinButton spinbutton1;
		Gtk.Button deleteValue;
		Gtk.ColorSelection colorselection;
		Gtk.Label labelValue;
		Gtk.FontSelection fontselection;

		TreeStore store;

		String lastName;
		int numOld;
		MiniGConf config;

		public MiniGConfEditor(MiniGConf config)
		{
			this.config = config;
			CreateUI();
			numOld = 0;
			CellRendererText nombre = new CellRendererText();
			CellRendererText edicion = new CellRendererText();
			edicion.Editable = false;
			tree_values.AppendColumn ("Name", nombre, "text", 0);
			tree_values.AppendColumn ("Value", edicion, "text", 1);
			tree_values.SearchColumn = 0;
			tree_values.EnableSearch = true;
			tree_values.Reorderable = false;
			tree_values.RulesHint = true;

			for (int i=0; i<=1; i++) {
				tree_values.Columns[i].Resizable = true;
				tree_values.Columns[i].SortColumnId = i;
			}

			tree_values.Columns[0].Reorderable = true;
			tree_values.Columns[0].SortIndicator = true;
			tree_values.Columns[0].SortOrder = SortType.Ascending;

			store = new TreeStore(typeof (string), typeof (string));
			store.SetSortColumnId(0,Gtk.SortType.Ascending);
			tree_values.Model = store;

			loadAll();

			config.OnChange += new MiniGConf.KeyHandler(OnChangeConfig);
			tree_values.Selection.Changed += new EventHandler (RowActivated);
			togglebutton1.Toggled += new EventHandler (ButtonToggled);
			entry1.Activated += new EventHandler (OnIntroEntry);
			spinbutton1.ValueChanged += new EventHandler (OnChangeSpin);
			colorselection.ColorChanged += new EventHandler (OnChangeColor);
			fontselection.WidgetEvent += new WidgetEventHandler(OnChangeFont);
			deleteValue.Clicked += new EventHandler (OnClickDelete);

		}

		void ButtonToggled (object obj, EventArgs args)
		{
			config.Set(lastName,togglebutton1.Active);
			togglebutton1.Label = togglebutton1.Active.ToString();
		}

		void loadAll()
		{

			if (numOld == config.DataList.Count) {
				Gtk.TreeIter iter;
				bool valid = store.GetIterFirst(out iter);
				while (valid) {
					store.SetValue(iter, 1, config.Get(store.GetValue(iter,0).ToString(),"").ToString());
					valid = store.IterNext(ref iter);
				}
				return;
			}

			numOld = config.DataList.Count;
			store.Clear();
			for (int i = 0; i < config.DataList.Count; i++)
				store.AppendValues(((MiniGConf.DataStruct) config.DataList [i]).name, ((MiniGConf.DataStruct) config.DataList [i]).value.ToString());

		}

		void OnChangeConfig(string key, object value)
		{
			loadAll();
			LoadRight(lastName);
		}

		void OnChangeSpin(object obj, EventArgs args)
		{
			switch (config.GetType(lastName,"")) {
				case "System.Int16":
					config.Set(lastName, (System.Int16)spinbutton1.Value);
					break;
				case "System.Int32":
					config.Set(lastName, (System.Int32)spinbutton1.Value);
					break;
				case "System.Int64":
					config.Set(lastName, (System.Int64)spinbutton1.Value);
					break;
			}
		}

		void OnChangeColor(object obj, EventArgs args)
		{
			double r, g, b;
			((HSV)((VBox)((HBox)colorselection.Children[0]).Children[0]).Children[0]).GetColor(out r, out g, out b);
			HSV.ToRgb(r, g, b, out r, out g, out b);
			config.Set(lastName, new Gdk.Color((byte) (r*255.0), (byte) (g*255.0), (byte) (b*255.0)));
		}

		void LoadRight(string value)
		{
			switch (config.GetType(value,"")) {
				case "System.Boolean":
					notebook1.CurrentPage = 1;
					if (togglebutton1.Active != System.Boolean.Parse(config.Get(value,"").ToString())) {
						togglebutton1.Active = System.Boolean.Parse(config.Get(value,"").ToString());
						togglebutton1.Label = config.Get(value,"").ToString();
					}
					break;
				case "System.String":
					notebook1.CurrentPage = 2;
					entry1.Text = config.Get(value,"").ToString();
					break;
				case "System.Int16":
					notebook1.CurrentPage = 3;
					if (spinbutton1.Value != System.Int16.Parse(config.Get(value,"").ToString())) {
						spinbutton1.SetRange(-32768,32767);
						spinbutton1.Value = System.Int16.Parse(config.Get(value,"").ToString());
					}
					break;
				case "System.Int32":
					notebook1.CurrentPage = 3;
					if (spinbutton1.Value != System.Int32.Parse(config.Get(value,"").ToString())) {
						spinbutton1.SetRange(-2147483648,2147483647);
						spinbutton1.Value = System.Int32.Parse(config.Get(value,"").ToString());
					}
					break;
				case "System.Int64":
					notebook1.CurrentPage = 3;
					if (spinbutton1.Value != System.Int64.Parse(config.Get(value,"").ToString())) {
						spinbutton1.SetRange(-9223372036854775808,9223372036854775807);
						spinbutton1.Value = System.Int64.Parse(config.Get(value,"").ToString());
					}
					break;
				case "Pango.FontDescription":
				if (!fontselection.FontName.Equals(config.Get(value,"").ToString()))
						fontselection.FontName = config.Get(value,"").ToString();
					notebook1.CurrentPage = 4;
					break;
				case "Gdk.Color":
					double r, g, b;
					((HSV)((VBox)((HBox)colorselection.Children[0]).Children[0]).Children[0]).GetColor(out r, out g, out b);
					HSV.ToRgb(r, g, b, out r, out g, out b);
					Gdk.Color aux = new Gdk.Color((byte) (r*255.0), (byte) (g*255.0), (byte) (b*255.0));
					if (!aux.Equal((Gdk.Color)config.Get(lastName, null))) {
						colorselection.CurrentColor = (Gdk.Color) config.Get(lastName, null);
						colorselection.PreviousColor = (Gdk.Color) config.Get(lastName, null);
					}
					notebook1.CurrentPage = 5;
					break;
				default:
					notebook1.CurrentPage = 0;
					break;
			}
			labelType.Text = config.GetType(value,"");

			if (notebook1.CurrentPage != 5)
				labelValue.Show();
			else
				labelValue.Hide();
		}


		void RowActivated(object sender, EventArgs a)
		{
			Gtk.TreeIter iter;
			Gtk.TreeModel model;

			if (tree_values.Selection.GetSelected (out model, out iter)) {
				lastName = store.GetValue(iter,0).ToString();
				LoadRight(lastName);
			}
		}

		void CreateUI()
		{
			MainWindow = new Gtk.Window("MiniGConf-Editor");

			togglebutton1 = new Gtk.ToggleButton();
			togglebutton1.Label = false.ToString();
			entry1 = new Gtk.Entry();
			spinbutton1 = new Gtk.SpinButton(-2147483648,2147483647,1);
			spinbutton1.Value = 0;

			notebook1 = new Gtk.Notebook();

			fontselection = new Gtk.FontSelection();

			colorselection = new Gtk.ColorSelection();
			colorselection.HasPalette = true;
			colorselection.HasOpacityControl = false;
			colorselection.SetSizeRequest (250, 200);

			notebook1.AppendPage (new Label ("Not developed"), new Label ("Nothing"));
			notebook1.AppendPage (togglebutton1, new Label ("Bool"));
			notebook1.AppendPage (entry1, new Label ("String"));
			notebook1.AppendPage (spinbutton1, new Label ("Integer"));
			notebook1.AppendPage (fontselection, new Label ("Font"));
			notebook1.AppendPage (colorselection, new Label ("Color"));

			Gtk.HBox hbox2 = new Gtk.HBox(false, 0);
			labelValue = new Gtk.Label("Value: ");
			hbox2.PackStart(labelValue, false, false, 10);
			hbox2.PackStart(notebook1, true, true, 10);

			labelType = new Gtk.Label("");

			Gtk.Frame frame1 = new Gtk.Frame();
			Gtk.HBox hbox1 = new Gtk.HBox(false, 0);
			hbox1.PackStart(new Gtk.Label("Type:"), false, false, 0);
			hbox1.PackStart(labelType, false, false, 0);
			frame1.LabelWidget = hbox1;

			deleteValue = new Gtk.Button("_Delete");
			HButtonBox hbuttonbox1 = new HButtonBox();
			hbuttonbox1.Add(deleteValue);
			hbuttonbox1.Layout = Gtk.ButtonBoxStyle.Start;
			hbuttonbox1.BorderWidth = 10;

			Gtk.VBox vbox2 = new Gtk.VBox(false, 0);
			vbox2.PackStart(hbox2, true, true, 0);
			vbox2.PackStart(hbuttonbox1, false, false, 0);

			frame1.Child = vbox2;

			tree_values = new Gtk.TreeView();
			Gtk.ScrolledWindow scrolled1 = new Gtk.ScrolledWindow();
			scrolled1.Add(tree_values);

			Gtk.HPaned hpaned1 = new Gtk.HPaned();
			hpaned1.Add1(scrolled1);
			hpaned1.Add2(frame1);
			Gtk.Statusbar status1 = new Gtk.Statusbar();

			MenuBar menu = new MenuBar();

			MenuItem file_item = new MenuItem("_File");
			MenuItem help_item = new MenuItem("_Help");

			menu.Append(file_item);
			menu.Append(help_item);

			Menu file_menu = new Menu();
			Menu help_menu = new Menu();

			file_item.Submenu = file_menu;
			help_item.Submenu = help_menu;

			MenuItem file_new = new MenuItem("New Window");
			MenuItem file_close = new MenuItem("Close Window");
			MenuItem file_separator = new SeparatorMenuItem();
			MenuItem exit = new MenuItem("_Exit");
			MenuItem about = new MenuItem("_About of...");

			file_new.Activated += new EventHandler(NewWindow);
			file_close.Activated += new EventHandler(Exit);
			exit.Activated += new EventHandler(Exit);

			file_menu.Append(file_new);
			file_menu.Append(file_close);
			file_menu.Append(file_separator);
			file_menu.Append(exit);

			help_menu.Append(about);

			Gtk.VBox vbox1 = new VBox(false,0);
			vbox1.PackStart(menu, false, false, 0);
			vbox1.PackStart(hpaned1, true, true, 0);
			vbox1.PackStart(status1, false, false, 0);

			MainWindow.Add(vbox1);
			tree_values.SetSizeRequest(275,300);
			hpaned1.Position = 275;
			MainWindow.ShowAll();

			togglebutton1.BorderWidth = 5;

			notebook1.ShowTabs = false;
			notebook1.ShowBorder = false;
			notebook1.CurrentPage = 0;
			tree_values.HeadersVisible=true;
		}

/*
		void OnChangeFont(object o, WidgetEventArgs args)
		{
			if (!fontselection.FontName.Equals(config.Get(lastName,"").ToString()))
				config.Set(lastName, Pango.FontDescription.FromString(fontselection.FontName));
		}

		void OnIntroEntry(object o, EventArgs args)
		{
			config.Set(lastName,entry1.Text);
		}

		void OnClickDelete(object sender, EventArgs args)
		{
			config.Del(lastName);
		}

		void Exit(object obj, EventArgs args)
		{
			MainWindow.Destroy();
		}

		void NewWindow(object obj, EventArgs args)
		{
			new MiniGConfEditor (config);
		}


	}
}
*/
